////////////////////////////////////////////////////////////////////////////
// 	WINLIMIT.CPP	limit windows size
////////////////////////////////////////////////////////////////////////////

#include <owl\applicat.h>
#include <owl\framewin.h>
#pragma hdrstop
#include "winlimit.rc"

class TWndw : public TFrameWindow
{
public:
	TWndw(TWindow *parent, const char far *title);
protected:
	void EvGetMinMaxInfo(MINMAXINFO far &minMaxInfo);
	void Paint(TDC& dc, BOOL /*erase*/, TRect& /*rect*/);
DECLARE_RESPONSE_TABLE(TWndw);
};
DEFINE_RESPONSE_TABLE1(TWndw, TFrameWindow)
	EV_WM_GETMINMAXINFO,
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow(parent, title)
{
	AssignMenu(MENU_1);
	Attr.X = 50;
	Attr.Y = 50;
	Attr.W = 300;
	Attr.H = 200;
}


void TWndw::EvGetMinMaxInfo(MINMAXINFO far &minMaxInfo)
{
	minMaxInfo.ptMaxSize.x = 400;
	minMaxInfo.ptMaxSize.y = 300;
	minMaxInfo.ptMinTrackSize.x = 200;
	minMaxInfo.ptMinTrackSize.y = 150;
	minMaxInfo.ptMaxTrackSize.x = 400;
	minMaxInfo.ptMaxTrackSize.y = 300;

	Invalidate();
	DefaultProcessing();
}


void TWndw::Paint(TDC& dc, BOOL /*erase*/, TRect& /*rect*/)
{
	char buf1[30], buf2[30];
	TRect client = GetClientRect();
	TRect window = GetWindowRect();
	wsprintf(buf1, "window = %dx%d", window.Width(), window.Height());
	wsprintf(buf2, "client = %dx%d", client.Width(), client.Height());
	dc.TextOut(10, 10, buf1);
	dc.TextOut(10, 30, buf2);
}

////////////////////////////////////////////////////////////////////////////
class TApp: public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};

///////////////////////////////////////////////////////////
void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw(0, "Limit Window");
	SetMainWindow(wndw);
}

////////////////////////////////////////////////////////////////////////////
int OwlMain(int, char*[])
{
	return TApp().Run();
}


